config/routes.rb
# frozen_string_literal: true

Rails.application.routes.draw do
  devise_for(
    :users,
    skip: [:registrations],
    controllers: { omniauth_callbacks: 'users/omniauth_callbacks' }
  )
  root 'restaurants#index'

  devise_scope :user do
    get 'signin' => 'devise/sessions#new', as: :new_user_session
    post 'signin' => 'devise/sessions#new', as: :session
    delete 'signout' => 'devise/sessions#destroy', as: :destroy_user_session
  end

  resources :restaurants do
    collection do
      post :search
      get :search, to: redirect('/restaurants')
    end
  end

  resources :events do
    collection do
      post :search
      get :search, to: redirect('/events')
    end
  end

  resources :restaurant_ratings, only: :create
end

app/models/application_record.rb
# frozen_string_literal: true

class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/event.rb
class Event < ApplicationRecord
  has_paper_trail

  validates :name, presence: true
  validates :occurs_on, presence: true, uniqueness: true

  belongs_to :restaurant, optional: true

  def self.next
    where(arel_table[:occurs_on].gt(Time.zone.today))
      .order(occurs_on: :asc)
      .first
  end

  def to_s
    name
  end
end

app/models/restaurant.rb
class Restaurant < ApplicationRecord
  has_paper_trail

  validates :food_type, presence: true
  validates :menu_url, presence: true
  validates :menu_url, uri: true
  validates :name, presence: true, uniqueness: { case_sensitive: false }

  has_many :events, dependent: :restrict_with_error

  has_many :restaurant_ratings, dependent: :destroy
  # View; no dependent option needed
  # rubocop:disable Rails/HasManyOrHasOneDependent
  has_many :user_ratings
  # rubocop:enable Rails/HasManyOrHasOneDependent

  scope :recent_picks, -> do
    joins(:events)
      .order(occurs_on: :desc)
      .where(
        Event.arel_table[:occurs_on].lt(Time.zone.today).and(
          Event.arel_table[:occurs_on].gt(1.month.ago)
        )
      )
  end

  def to_s
    name
  end

  def rating_for(user)
    restaurant_ratings.find { |rating| rating.user_id == user.id }
  end
end

app/models/restaurant_rating.rb
# A restaurant rating is a table-backed model that stores any rating information
# that has been added manually by a user. Currently, ratings are on a scale from
# 1 to 5 stars. This model is different from UserRating which is backed by a
# view and has a row for every user/restaurant combination (even if the user has
# not yet rated that restaurant).
class RestaurantRating < ApplicationRecord
  validates :stars, presence: true
  validates :stars, numericality: {
    only_integer: true,
    greater_than_or_equal_to: 1,
    less_than_or_equal_to: 5
  }
  validates :restaurant_id, uniqueness: { scope: :user_id }

  belongs_to :restaurant
  belongs_to :user
end

app/models/user.rb
class User < ApplicationRecord
  has_paper_trail
  devise :omniauthable, :timeoutable, :rememberable,
         omniauth_providers: [:google_oauth2]

  validates :email, presence: true, uniqueness: true

  has_many :restaurant_ratings, dependent: :destroy
  # View; no dependent option needed
  # rubocop:disable Rails/HasManyOrHasOneDependent
  has_many :user_ratings
  # rubocop:enable Rails/HasManyOrHasOneDependent
end

app/models/user_rating.rb
# A user rating is a view-backed model that is used to weight the randomization
# of restaurant options for a new WTL (see weekly_training_lunch_bot.rb). This
# view is the cross product of `users` and `restaurants`. If a RestaurantRating
# exists for a user/restaurant combo, the `rating` column consists of that
# restaurant ratings `stars`. If no RestaurantRating exists for that
# user/restaurant combination, the `rating` column on the UserRating will be set
# to a default value (currently 3, the value midway between the min and max
# manual rating values).
class UserRating < ApplicationRecord
  belongs_to :restaurant_rating, optional: true
  belongs_to :restaurant
  belongs_to :user

  def readonly?
    true
  end
end

app/controllers/application_controller.rb
# frozen_string_literal: true

class ApplicationController < ActionController::Base
  before_action :authenticate_user!

  private def ensure_admin
    return if current_user.admin?

    flash[:error] = 'Unauthorized action. Please ask an admin for approval.'
    redirect_back fallback_location: root_path
  end
end

app/controllers/events_controller.rb
class EventsController < ApplicationController
  before_action :ensure_admin, only: :destroy
  before_action :set_event, only: %i[show edit update destroy]

  def search
    index
    render :index
  end

  def index
    params[:q] ||= { s: 'name' }
    @search = Event.ransack(params[:q])
    @events = @search.result.page(params[:page])
  end

  def show
  end

  def new
    @event = Event.new
  end

  def create
    @event = Event.new(event_params)

    if @event.save
      redirect_to @event, success: 'Event was successfully created.'
    else
      render :new
    end
  end

  def edit
  end

  def update
    if @event.update(event_params)
      redirect_to @event, success: 'Event was successfully updated.'
    else
      render :edit
    end
  end

  def destroy
    if @event.destroy
      redirect_to events_url, success: 'Event was successfully destroyed.'
    else
      redirect_to events_url, warning: event.errors.to_sentence
    end
  end

  private def set_event
    @event = Event.find(params[:id])
  end

  private def event_params
    params.require(:event).permit(:name, :restaurant_id, :occurs_on)
  end
end

app/controllers/restaurant_ratings_controller.rb
class RestaurantRatingsController < ApplicationController
  def create
    rating = RestaurantRating.find_or_initialize_by(
      user: current_user,
      restaurant_id: params[:restaurant_id]
    )
    if rating.update(stars: params[:stars])
      head :ok
    else
      head :unprocessable_entity
    end
  end
end

app/controllers/restaurants_controller.rb
class RestaurantsController < ApplicationController
  before_action :ensure_admin, only: :destroy
  before_action :set_restaurant, only: %i[show edit update destroy]

  def search
    index
    render :index
  end

  def index
    params[:q] ||= { s: 'name' }
    @search = Restaurant.includes(:restaurant_ratings).ransack(params[:q])
    @restaurants = @search.result.page(params[:page])
  end

  def show
  end

  def new
    @restaurant = Restaurant.new
  end

  def create
    @restaurant = Restaurant.new(restaurant_params)

    if @restaurant.save
      redirect_to @restaurant, success: 'Restaurant was successfully created.'
    else
      render :new
    end
  end

  def edit
  end

  def update
    if @restaurant.update(restaurant_params)
      redirect_to @restaurant, success: 'Restaurant was successfully updated.'
    else
      render :edit
    end
  end

  def destroy
    if @restaurant.destroy
      redirect_to restaurants_url,
                  success: 'Restaurant was successfully destroyed.'
    else
      redirect_to restaurants_url, warning: restaurant.errors.to_sentence
    end
  end

  private def set_restaurant
    @restaurant = Restaurant.find(params[:id])
  end

  private def restaurant_params
    params.require(:restaurant).permit(:name, :menu_url, :food_type)
  end
end

app/controllers/users/omniauth_callbacks_controller.rb
module Users
  class OmniauthCallbacksController < Devise::OmniauthCallbacksController
    def google_oauth2
      omniauth = request.env['omniauth.auth']
      @user = from_omniauth(omniauth)

      if @user.present? && @user.persisted?
        flash[:notice] = I18n.t(
          'devise.omniauth_callbacks.success',
          kind: 'Google'
        )
        sign_in_and_redirect @user, event: :authentication
      else
        flash[:alert] = 'User not valid.'
        session['devise.google_data'] = omniauth.except(:extra)
        Rails.logger.error("Omniauth - User not valid. #{omniauth.inspect}")
        redirect_to new_session_path
      end
    end

    def failure
      redirect_to new_session_path
    end

    private def from_omniauth(access_token)
      data = access_token.info
      email = data['email'].to_s

      if email.end_with?('@scimedsolutions.com')
        user = User.find_or_create_by!(email: email)
      end

      user
    end
  end
end

app/helpers/application_helper.rb
# frozen_string_literal: true

module ApplicationHelper
end

app/helpers/restaurants_helper.rb
module RestaurantsHelper
end

app/views/events/_form.html.erb
<%= form_with(model: event, local: true, class: 'ui form') do |form| %>
  <% if event.errors.any? %>
    <div class="ui message">
      <h2 class="ui header">
        <%= pluralize(event.errors.count, 'error') %> prohibited this
        event from being saved:
      </h2>

      <ul class="list">
        <% event.errors.full_messages.each do |message| %>
          <li><%= message %></li>
        <% end %>
      </ul>
    </div>
  <% end %>

  <div class="ui field">
    <%= form.label :name %>
    <%= form.text_field :name, class: 'ui labeled input' %>
  </div>

  <div class="ui field">
    <%= form.label :occurs_on %>

    <div class="ui calendar">
      <div class="ui input left icon">
        <i class="calendar icon"></i>
        <%= form.text_field :occurs_on %>
      </div>
    </div>
  </div>

  <div class="ui field">
    <%= form.label :restaurant_id %>
    <%=
      form.select(
        :restaurant_id,
        options_for_select(Restaurant.order(:name).pluck(:name, :id), form.object.restaurant_id),
        { include_blank: true },
        class: 'ui fluid search dropdown'
      )
    %>
  </div>

  <div class="actions">
    <%= form.submit class: 'ui primary button' %>
  </div>
<% end %>

app/views/events/edit.html.erb
<h1 class="ui header">Editing Event</h1>

<%= render 'form', event: @event %>

<br>

<%= link_to 'Back', events_path, class: 'ui button' %>

app/views/events/index.html.erb
<h1 class="ui dividing header">
  Events
  <%= link_to new_event_path, class: 'ui right floated primary button' do %>
    <i class="plus circle icon"></i> New Event
  <% end %>
</h1>

<%= search_form_for @search, method: :post, url: search_events_path, html: { class: 'ui form' } do |f| %>
  <div class="two fields">
    <div class="field">
      <%= f.label :name_cont, 'Name' %>
      <%= f.text_field :name_cont %>
    </div>

    <div class="field">
      <%= f.label :restaurant_id_eq, 'Restaurant' %>
      <%=
        f.select(
          :restaurant_id_eq,
          options_for_select(
            Restaurant.order(:name).pluck(:name, :id),
            f.object.restaurant_id_eq
          ),
          { include_blank: true },
          class: 'ui fluid search dropdown'
        )
      %>
    </div>

    <div class="field">
      <%= f.label :occurs_on_gteq, 'Min Date' %>

      <div class="ui calendar">
        <div class="ui input left icon">
          <i class="calendar icon"></i>
          <%= f.text_field :occurs_on_gteq %>
        </div>
      </div>
    </div>

    <div class="field">
      <%= f.label :occurs_on_lteq, 'Max Date' %>

      <div class="ui calendar">
        <div class="ui input left icon">
          <i class="calendar icon"></i>
          <%= f.text_field :occurs_on_lteq %>
        </div>
      </div>
    </div>
  </div>

  <br>

  <%= f.submit class: 'ui primary button', data: { disable_with: 'Searching...' } %>
<% end %>

<div class="ui segment">
  <%= page_entries_info @events %>
</div>

<%= paginate @events %>

<table class="ui striped celled table">
  <thead>
    <tr>
      <th><%= sort_link @search, 'name', { action: :search }, method: :post %></th>
      <th>
        <%= sort_link @search, 'occurs_on', 'Date', { action: :search }, method: :post %>
      </th>
      <th>Restaurant</th>
      <th></th>
    </tr>
  </thead>

  <tbody>
    <% @events.each do |event| %>
      <tr>
        <td><%= event.name %></td>
        <td><%= event.occurs_on %></td>
        <td><%= link_to(event.restaurant, event.restaurant) if event.restaurant %></td>
        <td>
          <%= link_to event, class: 'ui secondary button' do %>
            <i class="eye icon"></i> Show
          <% end %>
          <%= link_to edit_event_path(event), class: 'ui secondary button' do %>
            <i class="pencil icon"></i> Edit
          <% end %>

          <% if current_user.admin? %>
            <%= link_to event, method: :delete, data: { confirm: 'Are you sure?' }, class: 'ui negative button' do %>
              <i class="trash icon"></i> Delete
            <% end %>
          <% end %>
        </td>
      </tr>
    <% end %>
  </tbody>
</table>

<%= paginate @events %>

app/views/events/new.html.erb
<h1 class="ui header">New Event</h1>

<%= render 'form', event: @event %>

<br>

<%= link_to 'Back', events_path, class: 'ui button' %>

app/views/events/show.html.erb
<h1 class="ui dividing header">
  <%= @event.name %>
  <%=
    link_to(
      content_tag(:i, '', class: 'undo icon') + ' Back',
      events_path,
      class: 'ui right floated button'
    )
  %>
  <%=
    link_to(
      content_tag(:i, '', class: 'pencil alternate icon') + ' Edit',
      edit_event_path(@event),
      class: 'ui right floated primary button'
    )
  %>
</h1>

<div class="ui large middle aligned list">
  <div class="item">
    <strong>Restaurant:</strong>
    <%= link_to @event.restaurant %>
  </div>

  <div class="item">
    <strong>Date:</strong>
    <%= @event.occurs_on %>
  </div>
</div>

<br>

<%= link_to 'Back', events_path, class: 'ui button' %>

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>Lunch Bot</title>
    <%= csrf_meta_tags %>
    <%= csp_meta_tag %>

    <%= stylesheet_link_tag    'application', media: 'all' %>
    <%= javascript_include_tag 'application' %>
  </head>

  <body>
    <div class="ui menu">
      <div class="ui container">
        <%= link_to 'Lunch Bot', root_path, class: 'header item' %>

        <% if current_user %>
          <%=
            link_to(
              'Restaurants',
              restaurants_path,
              class: "#{'active' if params[:controller] == 'restaurants'} item"
            )
          %>
          <%=
            link_to(
              'Events',
              events_path,
              class: "#{'active' if params[:controller] == 'events'} item"
            )
          %>
          <div class="right menu">
            <div class="item"><%= current_user.email %></div>
            <%= link_to 'Log Out', destroy_user_session_path, method: :delete, class: 'item' %>
          </div>
        <% end %>
      </div>
    </div>

    <div class="ui main container">
      <% flash.each do |key, value| %>
        <% next if value.blank? || key == 'timedout' %>

        <div class="ui <%= key %> message">
          <%= value %>
        </div>
      <% end %>

      <%= yield %>
    </div>
  </body>
</html>

app/views/restaurants/_form.html.erb
<%= form_with(model: restaurant, local: true, class: 'ui form') do |form| %>
  <% if restaurant.errors.any? %>
    <div class="ui message">
      <h2 class="ui header">
        <%= pluralize(restaurant.errors.count, 'error') %> prohibited this
        restaurant from being saved:
      </h2>

      <ul class="list">
        <% restaurant.errors.full_messages.each do |message| %>
          <li><%= message %></li>
        <% end %>
      </ul>
    </div>
  <% end %>

  <div class="ui field">
    <%= form.label :name %>
    <%= form.text_field :name, class: 'ui corner labeled input' %>
  </div>

  <div class="ui field">
    <%= form.label :menu_url %>
    <%= form.text_field :menu_url, class: 'ui corner labeled input' %>
  </div>

  <div class="ui field">
    <%= form.label :food_type %>
    <%=
      form.select(
        :food_type,
        options_for_select(Restaurant.all.pluck(:food_type).uniq, form.object.food_type),
        { include_blank: true },
        class: 'ui fluid search dropdown',
        data: { allow_additions: true }
      )
    %>
  </div>

  <div class="actions">
    <%= form.submit class: 'ui primary button' %>
  </div>
<% end %>

app/views/restaurants/edit.html.erb
<h1 class="ui header">Editing Restaurant</h1>

<%= render 'form', restaurant: @restaurant %>

<br>

<%= link_to 'Back', restaurants_path, class: 'ui button' %>

app/views/restaurants/index.html.erb
<h1 class="ui dividing header">
  Restaurants
  <%= link_to new_restaurant_path, class: 'ui right floated primary button' do %>
    <i class="plus circle icon"></i> New Restaurant
  <% end %>
</h1>

<%= search_form_for @search, method: :post, url: search_restaurants_path, html: { class: 'ui form' } do |f| %>
  <div class="two fields">
    <div class="field">
      <%= f.label :name_cont, 'Name' %>
      <%= f.text_field :name_cont %>
    </div>

    <div class="field">
      <%= f.label :food_type_eq, 'Food Type' %>
      <%=
        f.select(
          :food_type_eq,
          options_for_select(
            Restaurant.all.pluck(:food_type).uniq,
            f.object.food_type_eq
          ),
          { include_blank: true },
          class: 'ui fluid search dropdown'
        )
      %>
    </div>
  </div>

  <br>

  <%= f.submit class: 'ui primary button', data: { disable_with: 'Searching...' } %>
<% end %>

<div class="ui segment">
  <%= page_entries_info @restaurants %>
</div>

<%= paginate @restaurants %>

<table class="ui striped celled table">
  <thead>
    <tr>
      <th><%= sort_link @search, 'name', { action: :search }, method: :post %></th>
      <th><%= sort_link @search, 'food_type', { action: :search }, method: :post %></th>
      <th>Menu</th>
      <th>Your Rating</th>
      <th></th>
    </tr>
  </thead>

  <tbody>
    <% @restaurants.each do |restaurant| %>
      <tr>
        <td><%= restaurant.name %></td>
        <td><%= restaurant.food_type %></td>
        <td><%= link_to 'Menu', restaurant.menu_url %></td>
        <td>
          <%=
            content_tag(
              :div,
              '',
              class: 'ui large blue rating',
              data: {
                url: restaurant_ratings_path(restaurant_id: restaurant.id),
                rating: restaurant.rating_for(current_user).try(:stars)
              }
            )
          %>
        </td>
        <td>
          <%= link_to restaurant, class: 'ui secondary button' do %>
            <i class="eye icon"></i> Show
          <% end %>
          <%= link_to edit_restaurant_path(restaurant), class: 'ui secondary button' do %>
            <i class="pencil icon"></i> Edit
          <% end %>

          <% if current_user.admin? %>
            <%= link_to restaurant, method: :delete, data: { confirm: 'Are you sure?' }, class: 'ui negative button' do %>
              <i class="trash icon"></i> Delete
            <% end %>
          <% end %>
        </td>
      </tr>
    <% end %>
  </tbody>
</table>

<%= paginate @restaurants %>

app/views/restaurants/new.html.erb
<h1 class="ui header">New Restaurant</h1>

<%= render 'form', restaurant: @restaurant %>

<br>

<%= link_to 'Back', restaurants_path, class: 'ui button' %>

app/views/restaurants/show.html.erb
<h1 class="ui dividing header">
  <%= @restaurant.name %>
  <%=
    link_to(
      content_tag(:i, '', class: 'undo icon') + ' Back',
      restaurants_path,
      class: 'ui right floated button'
    )
  %>
  <%=
    link_to(
      content_tag(:i, '', class: 'pencil alternate icon') + ' Edit',
      edit_restaurant_path(@restaurant),
      class: 'ui right floated primary button'
    )
  %>
</h1>

<div class="ui large middle aligned list">
  <div class="item">
    <strong>Menu:</strong>
    <%= link_to 'Menu', @restaurant.menu_url %>
  </div>

  <div class="item">
    <strong>Food Type:</strong>
    <%= @restaurant.food_type %>
  </div>
</div>

<h3 class="ui header">Chosen for Events:</h2>

<table class="ui striped celled table">
  <thead>
    <tr>
      <th>Event</th>
      <th>Date</th>
      <th></th>
    </tr>
  </thead>

  <tbody>
    <% @restaurant.events.each do |event| %>
      <tr>
        <td><%= event.name %></td>
        <td><%= event.occurs_on %></td>
        <td><%= link_to 'Show', event, class: 'ui secondary button' %></td>
      </tr>
    <% end %>
  </tbody>
</table>

<br>

<%= link_to 'Back', restaurants_path, class: 'ui button' %>